//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "PieChartOptionsUnit.h"
#include "MainUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPieChartOptionsForm *PieChartOptionsForm;
TPieSeries *CurrentSeries = NULL;
float MinSingle = 1.5e-45;
float MaxSingle = 3.4e+38;
//---------------------------------------------------------------------------
__fastcall TPieChartOptionsForm::TPieChartOptionsForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::FormCreate(TObject *Sender)
{
   Icon = Application->Icon;   // put the icon on the form
   ChartPageControl->ActivePage = ChartSheet;     // when start up go to chart page
   Chart2PageControl->ActivePage = TitlesSheet;   // go to titles page of chart page
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ChartPageControlChange(TObject *Sender)
{
   if (ChartPageControl->ActivePage == SeriesSheet)
   {
      Series2PageControl->ActivePage = GeneralSheet;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::FormActivate(TObject *Sender)
{
   // chart title

   ChartTitleMemo->Lines->Clear();                                      // clear out the old text
   for (int i=0; i<MainForm->Chart1->Title->Text->Count; i++)           // load the title from chart
   {
      ChartTitleMemo->Lines->Add(MainForm->Chart1->Title->Text->Strings[i]);
   }

   ChartTitleMemo->Font = MainForm->Chart1->Title->Font;            // set up the font from chart
   ChartTitleBox->Checked = MainForm->Chart1->Title->Visible;       // make visible chart title box checked
   if (MainForm->Chart1->Title->Alignment == taLeftJustify)         // check to see if title is aligned left
   {
      TitleAlignmentGroup->ItemIndex = 0;                           // if it is set item index to 0
   }
   else if (MainForm->Chart1->Title->Alignment == taCenter)         // check to see if title is aligned centre
   {
      TitleAlignmentGroup->ItemIndex = 1;                           // if it is set item index to 1
   }
   else if (MainForm->Chart1->Title->Alignment == taRightJustify)   // check to see if title is aligned right
   {
      TitleAlignmentGroup->ItemIndex = 2;                           // if it is set item index to 2
   }

   // Legend

   LegendVisibleBox->Checked = MainForm->Chart1->Legend->Visible;   // check to see if legend visible
   FrameVisibleBox->Checked = true;
   //FrameVisibleBox->Checked = MainForm->Chart1->Frame->Visible;     // check to see if frame visible
   if (MainForm->Chart1->Legend->Alignment == laLeft)               // check to see if legend is aligned left
   {
      LegendPositionGroup->ItemIndex = 0;                           // if it is set item index to 0
   }
   else if (MainForm->Chart1->Legend->Alignment == laRight)         // check to see if legend is aligned right
   {
      LegendPositionGroup->ItemIndex =1;                            // if it is set item index to 1
   }
   else if (MainForm->Chart1->Legend->Alignment == laTop)           // check to see if legend is aligned top
   {
      LegendPositionGroup->ItemIndex = 2;                           // if it is set item index to 2
   }
   else if (MainForm->Chart1->Legend->Alignment == laBottom)        // check to see if legend is aligned bottom
   {
      LegendPositionGroup->ItemIndex = 3;                           // if it is set item index to 3
   }

   // Series

   TChartSeries *Series;                                                    // temporary reference for a series

   SeriesComboBox->Items->Clear();                                          // clear any series already in the box

   if (MainForm->Chart1->SeriesList->Count > 0)                             // if there is a series in the chart
   {
      for (int i=0; i<MainForm->Chart1->SeriesList->Count; i++)             // for each series
      {
         Series = (TChartSeries *)MainForm->Chart1->SeriesList->Items[i];   // find a series
         SeriesComboBox->Items->Add(Series->Title);                         // add the title of the series to the box
      }
   }

   if (SeriesComboBox->Items->Count > 0)                                    // if there is a series in the list
   {
      SeriesComboBox->ItemIndex = 0;                                        // put the first series in the box
   }

   SeriesComboBoxChange(Sender);                                            // change series combo box

   // margins

   TopUpDown->Position = MainForm->Chart1->MarginTop;                       // set top margin
   BottomUpDown->Position = MainForm->Chart1->MarginBottom;                 // set bottom margin
   LeftUpDown->Position = MainForm->Chart1->MarginLeft;                     // set left margin
   RightUpDown->Position = MainForm->Chart1->MarginRight;                   // set right margin

   PanelShape->Brush->Color = MainForm->Chart1->BackColor;                  // set the colour in the panel colour square
   BackColourShape->Brush->Color = MainForm->Chart1->Color;                 // set the colour in the background colour square
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ChartTitleMemoChange(TObject *Sender)
{
   MainForm->Chart1->Title->Text = ChartTitleMemo->Lines;   // changing the chart title
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ChartTitleFontButtonClick(
      TObject *Sender)
{
   FontDialog1->Font = MainForm->Chart1->Title->Font;      // set the initial font in font dialog box
   if (FontDialog1->Execute())
   {
      ChartTitleMemo->Font = FontDialog1->Font;                    // set the font in the chart title box
      MainForm->Chart1->Title->Font = FontDialog1->Font;   // set the font of the chart title
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ChartTitleBoxClick(TObject *Sender)
{
   MainForm->Chart1->Title->Visible = ChartTitleBox->Checked;   // show chart title
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::TitleAlignmentGroupClick(
      TObject *Sender)
{
   if (TitleAlignmentGroup->ItemIndex == 0)
   {
      MainForm->Chart1->Title->Alignment = taLeftJustify;    // align title at left
   }
   else if (TitleAlignmentGroup->ItemIndex == 1)
   {
      MainForm->Chart1->Title->Alignment = taCenter;         // align title at centre
   }
   else if (TitleAlignmentGroup->ItemIndex == 2)
   {
      MainForm->Chart1->Title->Alignment = taRightJustify;   // align title at right
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::PanelColourButtonClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Chart1->BackColor;           // set the initial colour in the colour dialog box
   if (ColorDialog1->Execute())
   {
      if ((MainForm->Chart1->Legend->Alignment == laLeft) || (MainForm->Chart1->Legend->Alignment == laRight))
      {
         int ExitCode = Application->MessageBox("Changing Panel Colour may obscure Legend. Continue?", "Warning",
            MB_YESNO|MB_ICONWARNING);

         switch(ExitCode)
         {                  
            case IDYES:
               MainForm->Chart1->BackColor = ColorDialog1->Color;        // set the colour in the centre of the chart (panel)
               PanelShape->Brush->Color = MainForm->Chart1->BackColor;   // set the colour in the panel colour square
               break;
         }
      }
      
      //MainForm->Chart1->BackColor = ColorDialog1->Color;        // set the colour in the centre of the chart (panel)
      //PanelShape->Brush->Color = MainForm->Chart1->BackColor;   // set the colour in the panel colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::BackColourButtonClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Chart1->Color;                // set the initial colour in the colour dialog box
   if (ColorDialog1->Execute())
   {
      MainForm->Chart1->Color = ColorDialog1->Color;             // set the background colour of the chart
      BackColourShape->Brush->Color = MainForm->Chart1->Color;   // set the colour in the background colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::LegendColourButtonClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Chart1->Legend->Color;            // set the initial colour in the colour dialog box
   if (ColorDialog1->Execute())
   {
      MainForm->Chart1->Legend->Color = ColorDialog1->Color;         // set the colour of the legend
      LegendShape->Brush->Color = MainForm->Chart1->Legend->Color;   // set the colour in the legend colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::FrameColourButtonClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Chart1->Legend->Frame->Color;           // set the initial colour in the colour dialog box
   if (ColorDialog1->Execute())
   {
      MainForm->Chart1->Legend->Frame->Color = ColorDialog1->Color;        // set the colour of the legend frame
      FrameShape->Brush->Color = MainForm->Chart1->Legend->Frame->Color;   // set the colour in the legend frame colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ShadowColourButtonClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Chart1->Legend->ShadowColor;            // set the initial colour in the colour dialog box
   if (ColorDialog1->Execute())
   {
      MainForm->Chart1->Legend->ShadowColor = ColorDialog1->Color;         // set the colour of the legend shadow
      ShadowShape->Brush->Color = MainForm->Chart1->Legend->ShadowColor;   // set the colour in the legend shadow colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::LegendFontButtonClick(TObject *Sender)
{
   FontDialog1->Font = MainForm->Chart1->Legend->Font;      // set the initial font in the font dialog box
   if (FontDialog1->Execute())
   {
      MainForm->Chart1->Legend->Font = FontDialog1->Font;   // set the legend font
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::LegendVisibleBoxClick(TObject *Sender)
{
   MainForm->Chart1->Legend->Visible = LegendVisibleBox->Checked;   // show legend
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::FrameVisibleBoxClick(TObject *Sender)
{
   MainForm->Chart1->Legend->Frame->Visible = FrameVisibleBox->Checked;   // show legend frame
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::LegendPositionGroupClick(
      TObject *Sender)
{
   if (LegendPositionGroup->ItemIndex == 0)
   {
      MainForm->Chart1->Legend->Alignment = laLeft;     // align legend at left
   }
   else if (LegendPositionGroup->ItemIndex == 1)
   {
      MainForm->Chart1->Legend->Alignment = laRight;    // align legend at right
   }
   else if (LegendPositionGroup->ItemIndex == 2)
   {
      MainForm->Chart1->Legend->Alignment = laTop;      // align legend at top
   }
   else if (LegendPositionGroup->ItemIndex == 3)
   {
      MainForm->Chart1->Legend->Alignment = laBottom;   // align legend at bottome
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::FrameWidthEditChange(TObject *Sender)
{
   MainForm->Chart1->Legend->Frame->Width = StrToInt(FrameWidthEdit->Text);   // set the legend frame width
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ShadowEditChange(TObject *Sender)
{
   MainForm->Chart1->Legend->ShadowSize = StrToInt(ShadowEdit->Text);   // set the legend shadow size
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::PanelSheetShow(TObject *Sender)
{
   PanelShape->Brush->Color = MainForm->Chart1->BackColor;              // set the colour in the panel colour square
   BackColourShape->Brush->Color = MainForm->Chart1->Color;             // set the colour in the background colour square
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::LegendSheetShow(TObject *Sender)
{
   LegendShape->Brush->Color = MainForm->Chart1->Legend->Color;         // set the colour in the legend colour square
   FrameShape->Brush->Color = MainForm->Chart1->Legend->Frame->Color;   // set the colour in the legend frame colour square
   ShadowShape->Brush->Color = MainForm->Chart1->Legend->ShadowColor;   // set the colour in the legend shadow colour square
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::SeriesComboBoxChange(TObject *Sender)
{
   if (SeriesComboBox->ItemIndex > -1)   // if there is a series in the box
   {
      CurrentSeries = (TPieSeries *)MainForm->Chart1->SeriesList->Items[SeriesComboBox->ItemIndex];   // set the current series to the series in the box
      SeriesVisibleBox->Checked = CurrentSeries->Active;                   // if series visible box is checked then current series is active
      SeriesLegendBox->Checked = CurrentSeries->ShowInLegend;              // if series legend visible box is checked then series is shown on legend
      SeriesTitleEdit->Text = CurrentSeries->Title;                        // put the current series' title in the title box
      CircledCheckBox->Checked = CurrentSeries->Circled;                   // if pie chart is a circle then check circled pie box
      D3CheckBox->Checked = MainForm->Chart1->View3D;                      // if 3D check 3D box
      Dark3DCheckBox->Checked = CurrentSeries->Dark3D;                     // if dark 3D check dark 3D box
      XRadiusEdit->Text = IntToStr(CurrentSeries->CustomXRadius);          // set the X radius
      YRadiusEdit->Text = IntToStr(CurrentSeries->CustomYRadius);          // set the Y radius
      if (XRadiusEdit->Text == 0)                                          // if X radius is zero
      {
         AutoXRadiusCheckBox->Checked = true;                              // auto X radius box is checked
      }
      else                                                                 // if X radius is not zero
      {
         AutoXRadiusCheckBox->Checked = false;                             // auto X radius box is not checked
      }

      if (YRadiusEdit->Text == 0)                                          // if Y radius is zero
      {
         AutoYRadiusCheckBox->Checked = true;                              // auto Y radius box is checked
      }
      else                                                                 // if Y radius is not zero
      {
         AutoYRadiusCheckBox->Checked = false;                             // auto Y radius box is not checked
      }

      BorderVisibleCheckBox->Checked = CurrentSeries->PiePen->Visible;     // check the border visible box if border is visible
      BorderWidthEdit->Text = IntToStr(CurrentSeries->PiePen->Width);      // set the width box to width of border
      BorderColourShape->Brush->Color = CurrentSeries->PiePen->Color;      // set the border colour square to colour of border
      if (CurrentSeries->PiePen->Style == psSolid)                         // loop through different border styles
      {
         BorderStyleRadioGroup->ItemIndex = 0;
      }
      else if (CurrentSeries->PiePen->Style == psDash)
      {
         BorderStyleRadioGroup->ItemIndex = 1;
      }
      else if (CurrentSeries->PiePen->Style == psDot)
      {
         BorderStyleRadioGroup->ItemIndex = 2;
      }
      else if (CurrentSeries->PiePen->Style == psDashDot)
      {
         BorderStyleRadioGroup->ItemIndex = 3;
      }
      else
      {
         BorderStyleRadioGroup->ItemIndex = 4;
      }

      MarksVisibleCheckBox->Checked = CurrentSeries->Marks->Visible;          // check the show marks box if marks are visible
      MarksShape->Brush->Color = CurrentSeries->Marks->BackColor;             // set the marks colour square to background colour of marks

      MarksBorderCheckBox->Checked = CurrentSeries->Marks->Frame->Visible;    // check the marks border visible box if marks' frame is visible
      MarksBorderEdit->Text = IntToStr(CurrentSeries->Marks->Frame->Width);   // set the width box to width of marks' frame
      MarksBorderShape->Brush->Color = CurrentSeries->Marks->Frame->Color;    // set the marks' border colour square to colour of marks' frame
      if (CurrentSeries->Marks->Frame->Style == psSolid)                      // loop through different border styles
      {
         MarksBorderRadioGroup->ItemIndex = 0;
      }
      else if (CurrentSeries->Marks->Frame->Style == psDash)
      {
         MarksBorderRadioGroup->ItemIndex = 1;
      }
      else if (CurrentSeries->Marks->Frame->Style == psDot)
      {
         MarksBorderRadioGroup->ItemIndex = 2;
      }
      else if (CurrentSeries->Marks->Frame->Style == psDashDot)
      {
         MarksBorderRadioGroup->ItemIndex = 3;
      }
      else
      {
         MarksBorderRadioGroup->ItemIndex = 4;
      }

       if (CurrentSeries->Marks->Style == smsPercent)                         // loop through different marks styles
      {
         MarksStyleRadioGroup->ItemIndex = 0;
      }
      else if (CurrentSeries->Marks->Style == smsLabel)
      {
         MarksStyleRadioGroup->ItemIndex = 1;
      }
      else
      {
         MarksStyleRadioGroup->ItemIndex = 2;
      }

      ArrowShape->Brush->Color = CurrentSeries->Marks->Arrow->Color;          // set the arrow colour square to the colour of the marks' arrow
      ArrowLengthEdit->Text = IntToStr(CurrentSeries->Marks->ArrowLength);    // set the arrow length
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::SeriesTitleEditChange(
      TObject *Sender)
{
   CurrentSeries->Title = SeriesTitleEdit->Text;                            // set the title to current series' title

   // change the title in the combo box as well

   TChartSeries *Series;                                                    // temporary reference for a series
   int OldItemIndex = SeriesComboBox->ItemIndex;                            // remember which item is selected
   SeriesComboBox->Items->Clear();                                          // clear any series already in the combo box

   if (MainForm->Chart1->SeriesList->Count > 0)                             // if there is a series in the chart
   {
      for (int i=0; i<MainForm->Chart1->SeriesList->Count; i++)             // for each series
      {
         Series = (TChartSeries *)MainForm->Chart1->SeriesList->Items[i];   // find a series
         SeriesComboBox->Items->Add(Series->Title);                         // add the title of the series to the combo box
      }
   }

   SeriesComboBox->ItemIndex = OldItemIndex;                                // put the previously selected series back in the box
   SeriesComboBoxChange(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::SeriesVisibleBoxClick(TObject *Sender)
{
   if (CurrentSeries != NULL)
   {
      MainForm->Series1->Active = SeriesVisibleBox->Checked;
      //CurrentSeries->Active = SeriesVisibleBox->Checked;   // if series visible box is checked show series
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::SeriesLegendBoxClick(TObject *Sender)
{
   if (CurrentSeries != NULL)
   {
      MainForm->Series1->ShowInLegend = SeriesLegendBox->Checked;   // if series legend box is checked show series in legend
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::TopUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
   MainForm->Chart1->MarginTop = TopUpDown->Position;   // set the top margin
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::BottomUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
   MainForm->Chart1->MarginBottom = BottomUpDown->Position;   // set the bottom margin
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::LeftUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
   MainForm->Chart1->MarginLeft = LeftUpDown->Position;   // set the left margin
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::RightUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
   MainForm->Chart1->MarginRight = RightUpDown->Position;   // set the right margin
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::CircledCheckBoxClick(TObject *Sender)
{
   MainForm->Series1->Circled = CircledCheckBox->Checked;   // draw pie chart as a circle
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::D3CheckBoxClick(TObject *Sender)
{
   if (D3CheckBox->Checked == true)       // if 3D
   {
      MainForm->Chart1->View3D = true;    // draw pie chart in 3D
      Dark3DCheckBox->Enabled = true;     // enable dark 3D check box
   }
   else
   {
      Dark3DCheckBox->Enabled = false;    // can't change dark 3D box
      MainForm->Chart1->View3D = false;   // show in 1D
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::Dark3DCheckBoxClick(TObject *Sender)
{
   CurrentSeries->Dark3D = Dark3DCheckBox->Checked;   // fill the borders with darker colours
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::AutoXRadiusCheckBoxClick(
      TObject *Sender)
{
   if (AutoXRadiusCheckBox->Checked)      // if automatic X radius box checked
   {
      CurrentSeries->CustomXRadius = 0;   // set X radius to automatic
      XRadiusEdit->Text = 0;              // set X radius in box to zero
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::XRadiusEditChange(TObject *Sender)
{
   CurrentSeries->CustomXRadius = StrToInt(XRadiusEdit->Text);   // set X radius size

   if (XRadiusEdit->Text == 0)                                   // if X radius set to zero
   {
      AutoXRadiusCheckBox->Checked = true;                       // auto X radius box is checked
   }
   else                                                          // if X radius is not set to zero
   {
      AutoXRadiusCheckBox->Checked = false;                      // auto X radius box is not checked
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::YRadiusEditChange(TObject *Sender)
{
   CurrentSeries->CustomYRadius = StrToInt(YRadiusEdit->Text);   // set Y radius size

   if (YRadiusEdit->Text == 0)                                   // if Y radius set to zero
   {
      AutoYRadiusCheckBox->Checked = true;                       // auto Y radius box is checked
   }
   else                                                          // if Y radius is not set to zero
   {
      AutoYRadiusCheckBox->Checked = false;                      // auto Y radius box is not checked
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::AutoYRadiusCheckBoxClick(
      TObject *Sender)
{
   if (AutoYRadiusCheckBox->Checked)      // if automatic Y radius box is checked
   {
      CurrentSeries->CustomYRadius = 0;   // set Y radius to automatic
      YRadiusEdit->Text = 0;              // set Y radius in box to zero
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::BorderVisibleCheckBoxClick(
      TObject *Sender)
{
   CurrentSeries->PiePen->Visible = BorderVisibleCheckBox->Checked;   // show border
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::BorderWidthEditChange(
      TObject *Sender)
{
   CurrentSeries->PiePen->Width = StrToInt(BorderWidthEdit->Text);   // set width of border
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::BorderColourButtonClick(
      TObject *Sender)
{
   if (ColorDialog1->Execute())
   {
      CurrentSeries->PiePen->Color = ColorDialog1->Color;               // set colour of border
      BorderColourShape->Brush->Color = CurrentSeries->PiePen->Color;   // set the colour in the border colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::BorderStyleRadioGroupClick(
      TObject *Sender)
{
   if (BorderStyleRadioGroup->ItemIndex == 0)        // loop through the border styles setting border to each
   {
      CurrentSeries->PiePen->Style = psSolid;
   }
   else if (BorderStyleRadioGroup->ItemIndex == 1)
   {
      CurrentSeries->PiePen->Style = psDash;
   }
   else if (BorderStyleRadioGroup->ItemIndex == 2)
   {
      CurrentSeries->PiePen->Style = psDot;
   }
   else if (BorderStyleRadioGroup->ItemIndex == 3)
   {
      CurrentSeries->PiePen->Style = psDashDot;
   }
   else
   {
      CurrentSeries->PiePen->Style = psDashDotDot;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksVisibleCheckBoxClick(
      TObject *Sender)
{
   CurrentSeries->Marks->Visible = MarksVisibleCheckBox->Checked;   // show marks        
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksColourButtonClick(
      TObject *Sender)
{
   if (ColorDialog1->Execute())
   {
      CurrentSeries->Marks->BackColor = ColorDialog1->Color;        // set background colour of marks
      MarksShape->Brush->Color = CurrentSeries->Marks->BackColor;   // set the colour in the marks colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksFontButtonClick(TObject *Sender)
{
   FontDialog1->Font = CurrentSeries->Marks->Font;      // set the initial font in font dialog box
   if (FontDialog1->Execute())
   {
      CurrentSeries->Marks->Font = FontDialog1->Font;   // set the marks' font
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksBorderCheckBoxClick(
      TObject *Sender)
{
   CurrentSeries->Marks->Frame->Visible = MarksBorderCheckBox->Checked;   // show frame around marks
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksBorderEditChange(
      TObject *Sender)
{
   CurrentSeries->Marks->Frame->Width = StrToInt(MarksBorderEdit->Text);   // set width of marks' frame
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksBorderColourButtonClick(
      TObject *Sender)
{
   if (ColorDialog1->Execute())
   {
      CurrentSeries->Marks->Frame->Color = ColorDialog1->Color;              // set colour of marks' frame
      MarksBorderShape->Brush->Color = CurrentSeries->Marks->Frame->Color;   // set the colour in the marks' frame colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksBorderRadioGroupClick(
      TObject *Sender)
{
   if (MarksBorderRadioGroup->ItemIndex == 0)                                // loop through the border styles setting frame border to each
   {
      CurrentSeries->Marks->Frame->Style = psSolid;
   }
   else if (MarksBorderRadioGroup->ItemIndex == 1)
   {
      CurrentSeries->Marks->Frame->Style = psDash;
   }
   else if (MarksBorderRadioGroup->ItemIndex == 2)
   {
      CurrentSeries->Marks->Frame->Style = psDot;
   }
   else if (MarksBorderRadioGroup->ItemIndex == 3)
   {
      CurrentSeries->Marks->Frame->Style = psDashDot;
   }
   else
   {
      CurrentSeries->Marks->Frame->Style = psDashDotDot;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::MarksStyleRadioGroupClick(
      TObject *Sender)
{
   if (MarksStyleRadioGroup->ItemIndex == 0)                                   // loop through the marks' styles
   {
      CurrentSeries->Marks->Style = smsPercent;
   }
   else if (MarksStyleRadioGroup->ItemIndex == 1)
   {
      CurrentSeries->Marks->Style = smsLabel;
   }
   else 
   {
      CurrentSeries->Marks->Style = smsLabelPercent;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ArrowColourButtonClick(
      TObject *Sender)
{
   if (ColorDialog1->Execute())
   {
      CurrentSeries->Marks->Arrow->Color = ColorDialog1->Color;        // set colour of marks' arrow
      ArrowShape->Brush->Color = CurrentSeries->Marks->Arrow->Color;   // set the colour in the marks' arrow colour square
   }
}
//---------------------------------------------------------------------------

void __fastcall TPieChartOptionsForm::ArrowLengthEditChange(
      TObject *Sender)
{
   CurrentSeries->Marks->ArrowLength = StrToInt(ArrowLengthEdit->Text);   // set length of arrow        
}
//---------------------------------------------------------------------------


